#include "ChatServer.h"
#ifdef WIN32
#include <main.h>
#endif
#include <Zeit.h>
#include <iostream>
#include <fstream>
#include <Globals.h>

#ifdef WIN32
int KSGStart Framework::Start( Startparam p )
{
#else
int main()
{
    Framework::initFramework();
#endif
	Zeit *z = getZeit();
	Text *pfad = new Text( "../log/chat/" );
	pfad->append( z->getZeit( "y-m-d h-i-s.log" ) );
	z->release();
	DateiPfadErstellen( pfad->getThis() );
	std::ofstream file;
	file.open( pfad->getText() );
	std::streambuf* sbuf = std::cout.rdbuf();
	std::cout.rdbuf( file.rdbuf() );
	pfad->release();

	std::cout << "CS: Startet...\n";
	std::cout << "CS: Lese init Datei ../data/csInit.ini ...\n";
	InitDatei *dat = new InitDatei( "../data/csInit.ini" );
	if( !dat->laden() )
	{
		std::cout << "CS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
		dat->release();
		exit( 1 );
	}

	ChatServer *cServer = new ChatServer( dat );

	std::cout << "CS: Der Admin Server läuft. Startforgang beendet.\n";
	cServer->runn();

	cServer->ende();
	cServer->release();
	dat->speichern();
	dat->release();
	std::cout << "CS: Der Server ist heruntergefahren.\n";
	file.close();
	std::cout.rdbuf( sbuf );
#ifndef WIN32
    Framework::releaseFramework();
#endif
	return 0;
}